% Copyright (C) 2008-2010 - Consortium Scilab - Digiteo - Michael Baudin
%
% This file must be used under the terms of the 
% Creative Commons Attribution-ShareAlike 3.0 Unported License :
% http://creativecommons.org/licenses/by-sa/3.0/

\section{Complex division}

In this section, we analyze the problem of the complex division in Scilab.
We especially detail the difference between the mathematical, straightforward
formula and the floating point implementation. In the first part, we briefly report 
the formulas which allow to 
compute the real and imaginary parts of the division of two complex numbers.
We then present the naive algorithm based on these mathematical formulas. 
In the second part, we make some experiments in Scilab and compare our
naive algorithm with Scilab's division operator.
In the third part, we analyze 
why and how floating point numbers must be taken into account when the 
implementation of such division is required.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Theory}

Assume that $a,b,c$ and $d$ are four real numbers.
Consider the two complex numbers $a + ib$ and $c + id$, where $i$ is 
the imaginary number which satisfies $i^2=-1$. Assume that $c^2 + d^2$ is non zero.
We are interested in the complex number $e+fi = \frac{a + ib}{c + id}$ where $e$ and $f$ are real
numbers.
The formula which allows to compute the real and imaginary parts 
of the division of these two complex numbers is 
\begin{eqnarray}
\label{compdiv-eq-defcomplexdiv}
\frac{a + ib}{c + id} = \frac{ac + bd}{c^2 + d^2} + i \frac{bc - ad}{c^2 + d^2} .
\end{eqnarray}
So that the real and imaginary parts $e$ and $f$ of the complex number are
\begin{eqnarray}
\label{compdiv-eq-e}
e &=& \frac{ac + bd}{c^2 + d^2}, \\
\label{compdiv-eq-f}
f &=& \frac{bc - ad}{c^2 + d^2}.
\end{eqnarray}

The naive algorithm for the computation of the complex division
is presented in figure \ref{naive-complexdivision}.

\begin{algorithm}[htbp]
\SetKwInOut{Input}{input}\SetKwInOut{Output}{output}
\Input{$a,b,c,d$}
\Output{$e,f$}
$den := c^2 + d^2$\;
$e := (ac + bd)/ den$\;
$f := (bc - ad)/ den$\;
\caption{Naive algorithm to compute the complex division. The algorithm takes as input the 
real and imaginary parts $a,b,c,d$ of the two complex numbers and returns 
$e$ and $f$, the real and imaginary parts of the division.}
\label{naive-complexdivision}
\end{algorithm}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Experiments}

The following Scilab function \scifun{naive} is a straightforward implementation
of the previous formulas. It takes as input the complex numbers $a$ and $b$, 
represented by their real and imaginary parts \scivar{a}, \scivar{b}, \scivar{c} and 
\scivar{d}. The function \scifun{naive} returns the complex number represented 
by its real and imaginary parts \scivar{e} and \scivar{f}.
\lstset{language=scilabscript}
\begin{lstlisting}
function [e,f] = naive (a , b , c , d )
  den = c * c + d * d;
  e = (a * c + b * d) / den;
  f = (b * c - a * d) / den;
endfunction
\end{lstlisting}

Consider the complex division
\begin{eqnarray}
\label{eq-cd-firstest}
\frac{1 + i2}{3 + i4} = \frac{11}{25}+i \frac{2}{25}= 0.44 +i 0.08 .
\end{eqnarray}
We check our result with Wolfram Alpha\cite{WWWWolframAlpha}, with 
the input "(1+i*2)/(3+i*4)".
In the following script, we check that there is no obvious bug 
in the naive implementation.
\lstset{language=scilabscript}
\begin{lstlisting}
-->  [e f] = naive ( 1.0 , 2.0 , 3.0 , 4.0 )
 f  =
    0.08  
 e  =
    0.44  
-->  (1.0 + %i * 2.0 )/(3.0 + %i * 4.0 )
 ans  =
    0.44 + 0.08i  
\end{lstlisting}
The results of the \scifun{naive} function and the division operator are the same,
which makes us confident that our implementation is correct.

Now that we are confident, we make the following numerical experiment involving 
a large number. Consider the complex division 
\begin{eqnarray}
\label{eq-cd-10307}
\frac{1 + i}{1 + i 10^{307}  } \approx 1.0000000000000000\cdot 10^{-307} - i 1.0000000000000000\cdot 10^{-307} ,
\end{eqnarray}
which is accurate to the displayed digits. 
We check our result with Wolfram Alpha\cite{WWWWolframAlpha}, with 
the input "(1 + i)/(1 + i * 10$\hat{\;}$307)".
In fact, there are more that 300 zeros following the leading 
1, so that the previous approximation is very accurate.
The following Scilab session compares the naive implementation and Scilab's division operator.
\lstset{language=scilabscript}
\begin{lstlisting}
-->  [e f] = naive ( 1.0 , 1.0 , 1.0 , 1.e307 )
 f  =
    0.  
 e  =
    0.  
-->  (1.0 + %i * 1.0)/(1.0 + %i * 1.e307)
 ans  =
    1.000-307 - 1.000-307i  
\end{lstlisting}
In the previous case, the naive implementation does not produce any correct digit!

The last test involves small numbers in the denominator of the complex fraction.
Consider the complex division 
\begin{eqnarray}
\label{eq-cd-thirdtest}
\frac{1 + i}{10^{-307} +  i 10^{-307} }= \frac{1 + i}{10^{-307}(1 +  i)} = 10^{307}.
\end{eqnarray}
In the following session, the first statement \scifun{ieee(2)} configures the 
IEEE system so that Inf and Nan numbers are generated instead 
of Scilab error messages. 
\lstset{language=scilabscript}
\begin{lstlisting}
-->ieee(2);
-->[e f] = naive ( 1.0 , 1.0 , 1.e-307 , 1.e-307 )
 f  =
   Nan  
 e  =
   Inf  
-->(1.0 + %i * 1.0)/(1.e-307 + %i * 1.e-307)
 ans  =
    1.000+307  
\end{lstlisting}
We see that the naive implementation generates the IEEE numbers Nan and Inf, while the 
division operator produces the correct result.

\begin{ignorepart}
To make more complete tests, the following script allows to 
compare the results of the naive and the Scilab methods.
Consider the two complex numbers $x = x^R+i x^I\in\CC$ and $y = y^R+iy^I\in\CC$,
where $x^R, x^I, y^R, y^I \in\RR$, $x$ is the expected number and $y$ is the computed number.
When we compute the relative error, we can separately analyze the relative error 
on the complex number, or the relative error on the real and imaginary parts.
This leads to the following three relative errors 
\begin{enumerate}
\item the relative error on the complex numbers, $\frac{|x - y|}{|x|}$, if $|x|\neq 0$,
\item the relative error on the real part $\frac{|x^R - y^R|}{x^R}$, if $|x^R|\neq 0$,
\item the relative error on the imaginary part $\frac{|x^I - y^I|}{x^I}$, if $|x^I|\neq 0$.
\end{enumerate}
If the denominator of these fractions are zero, we use an absolute error instead.
The following function \scifun{myerror} computes a relative error when the expected number 
is nonzero, and computes an absolute error if not. The input arguments $x$ and $y$
can be either complex or real numbers.
\lstset{language=scilabscript}
\begin{lstlisting}
function err = myerror ( x , y )
  if ( expected == 0 ) then
    err = abs(x - y);
  else
    err = abs(x - y)/abs(yd);
  end
endfunction
\end{lstlisting}
The following function \scifun{complexerrors} computes 
the three types of errors than we have presented on the complex numbers $x$ and $y$.
\lstset{language=scilabscript}
\begin{lstlisting}
function complexerrors ( x , y )
  err1 = myerror ( x , y );
  err2 = myerror ( real(x) , real(y) );
  err3 = myerror ( imag(x) , imag(y) );
  printf("   e1 = %10.5e, e2 = %10.5e, e3 = %10.5e\n", err1, err2, err3);
endfunction
\end{lstlisting}
The following \scifun{compare} function compares the results 
produced by the \scifun{naive} division function and Scilab's division
operator. The input arguments $a,b,c,d$ are real numbers representing the 
division $(a+ib)/(c+id)$ and the input arguments $e$ and $f$ are the expected 
real and imaginary parts for the division.
\lstset{language=scilabscript}
\begin{lstlisting}
function compare (a, b, c, d, e, f)
  printf("****************\n");
  printf("           %10.5e +  I * %10.5e\n" , a ,  b );
  printf("         / %10.5e +  I * %10.5e\n" , c ,  d );
  printf("         = %10.5e +  I * %10.5e\n" , e ,  f );
  // Use naive computation
  [e1 f1] = naive ( a, b, c, d);
  printf("Naive  --> %10.5e +  I * %10.5e\n" , e1 ,  f1 );
  complexerrors ( e1 + %i * f1 , e + %i * f );
  // Use Scilab's division operator.
  div = (a + %i * b )/(c + %i * d );
  printf("Scilab --> %10.5e +  I * %10.5e\n" , real(div) ,  imag(div) );
  complexerrors ( div , e + %i * f );
endfunction
\end{lstlisting}

In the following script, we compare the naive and the Scilab
implementations of the complex division with 4 couples of 
complex numbers. 
The first instruction "ieee(2)" configures the 
IEEE system so that Inf and Nan numbers are generated instead 
of Scilab error messages.
\lstset{language=scilabscript}
\begin{lstlisting}
ieee(2);
\end{lstlisting}
Then we call the \scifun{compare} function on the three test cases
that we have presented before.
\lstset{language=scilabscript}
\begin{lstlisting}
compare (1,2,3,4, 11/25, 2/25);
compare (1, 1, 1, 1e307, 1e-307, -1e-307);
compare (1, 1, 1e-307, 1e-307, 1e307, 0.);
\end{lstlisting}

The previous script produces the following output.
\begin{lstlisting}
****************
           1.00000e+000 +  I * 2.00000e+000
         / 3.00000e+000 +  I * 4.00000e+000
         = 4.40000e-001 +  I * 8.00000e-002
Naive  --> 4.40000e-001 +  I * 8.00000e-002
   e1 = 0.00000e+000, e2 = 0.00000e+000, e3 = 0.00000e+000
Scilab --> 4.40000e-001 +  I * 8.00000e-002
   e1 = 0.00000e+000, e2 = 0.00000e+000, e3 = 0.00000e+000
****************
           1.00000e+000 +  I * 1.00000e+000
         / 1.00000e+000 +  I * 1.00000e+307
         = 1.00000e-307 +  I * -1.00000e-307
Naive  --> 0.00000e+000 +  I * -0.00000e+000
   e1 = 1.00000e+000, e2 = 1.00000e+000, e3 = 1.00000e+000
Scilab --> 1.00000e-307 +  I * -1.00000e-307
   e1 = 2.09614e-016, e2 = 1.97626e-016, e3 = 1.97626e-016
****************
           1.00000e+000 +  I * 1.00000e+000
         / 1.00000e-307 +  I * 1.00000e-307
         = 1.00000e+307 +  I * 0.00000e+000
Naive  --> Inf +  I * Nan
   e1 = Nan, e2 = Nan, e3 = Nan
Scilab --> 1.00000e+307 +  I * 0.00000e+000
   e1 = 1.24740e-016, e2 = 1.24740e-016, e3 = 0.00000e+000
\end{lstlisting}

The case \#2 and \#3 shows very surprising results.
With case \#2, the relative errors shows that the naive 
implementation does not give any correct digit.
In case \#3, the naive implementation produces Nan and Inf results.
In both cases, the Scilab division operator gives accurate results, i.e.,
with 16 significant digits.
\end{ignorepart}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{Explanations}

In this section, we analyze the reason why the naive implementation
of the complex division leads to inaccurate results.
In the first section, we perform algebraic computations 
and shows the problems of the naive formulas.
In the second section, we present the Smith's method.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsubsection{Algebraic computations}

In this section, we analyze the results produced by the second and third tests in the 
previous numerical experiments. We show that the intermediate numbers which appear
are not representable as double precision floating point numbers.

Let us analyze the second complex division \ref{eq-cd-10307}.
We are going to see that this division is associated with 
an IEEE overflow.
We have $a=1$, $b=1$, $c=1$ and $d=10^{307}$.
By the equations \ref{compdiv-eq-e} and \ref{compdiv-eq-f}, we have 
\begin{eqnarray}
den &=& c^2 + d^2 = 1^2 + (10^{307})^2 \\
  &=& 1 + 10^{614} \approx 10^{614}, \\
e &=& (ac + bd)/ den = (1*1 + 1*10^{307})/10^{614}, \\
  &\approx& 10^{307}/10^{614}  \approx 10^{-307},\\
f &=& (bc - ad)/ den = (1*1 - 1*10^{307})/10^{614} \\
  &\approx& -10^{307}/10^{614} \approx -10^{-307}.
\end{eqnarray}
We see that both the input numbers $a,b,c,d$ are representable 
and the output numbers $e=10^{-307}$ and $f=-10^{-307}$ are representable as double precision
floating point numbers.
We now focus on the floating point representation of the intermediate expressions.
We have 
\begin{eqnarray}
fl(den) = fl(10^{614}) = Inf,
\end{eqnarray}
because $10^{614}$ is not representable as a double precision number. 
Indeed, the largest positive double is $10^{308}$.
The IEEE Inf floating point number stands for Infinity and is associated with an overflow. 
The Inf floating point number is associated with an algebra which defines that $1/Inf = 0$. 
This is consistent with mathematical limit of the function $1/x$ when $x\rightarrow \infty$.
Then, the $e$ and $f$ terms are computed as 
\begin{eqnarray}
fl(e) &=& fl((ac + bd)/ den) = fl((1*1 + 1*10^{307})/Inf) = fl(10^{307}/Inf) = 0,\\
fl(f) &=& fl((bc - ad)/ den) = fl((1*1 - 1*10^{307})/Inf) = fl(-10^{307}/Inf) = 0.
\end{eqnarray}
Hence, the result is computed without any significant digit,
even though both the input and the output numbers are all representable as double precision
floating point numbers.

Let us analyze the second complex division \ref{eq-cd-thirdtest}.
We are going to see that this division is associated with 
an IEEE underflow.
We have $a=1$, $b=1$, $c=10^{-307}$ and $d=10^{-307}$.
We now use the equations \ref{compdiv-eq-e} and \ref{compdiv-eq-f}, which leads to:
\begin{eqnarray}
den &=& c^2 + d^2 = (10^{-307})^2 + (10^{-307})^2 \\
  &=& 10^{-614} + 10^{-614} = 2 . 10^{-616}, \\
e &=& (ac + bd)/ den = (1*10^{-307} + 1*10^{-307})/(2 . 10^{-614}) \\
 &=&  (2 . 10^{-307})/(2 . 10^{-614}) = 10^{307}, \\
f &=& (bc - ad)/ den = (1*10^{-307} - 1*10^{-307})/(2 . 10^{-614}) \\
  &=& 0/10^{-614} = 0.
\end{eqnarray}
With double precision floating point numbers, the computation is not performed this way.
The positive terms which are smaller than $10^{-324}$ are too small to be representable 
in double precision and are represented by 0 so that an underflow occurs.
This leads to
\begin{eqnarray}
fl(den) &=& fl(c^2 + d^2) = fl(10^{-614} + 10^{-614}) \\
&=& 0, \\
fl(e) &=& fl((ac + bd)/ den) = fl((1*10^{-307} + 1*10^{-307})/(2 . 10^{-614}))  \\
&=& fl( 2. 10^{-307}/0 ) = Inf, \\
fl(f) &=& fl((bc - ad)/ den) = fl((1*10^{-307} - 1*10^{-307})/0)  \\
&=& fl(0/0) = NaN.
\end{eqnarray}

The two previous examples shows that, even if both the input and output numbers are 
representable as floating point numbers, the intermediate expressions 
may generate numbers which may not be representable as floating point 
numbers. Hence, a naive implementation can lead to inaccurate results.
In the next section, we present a method which allows to cure most 
problems generated by the complex division.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsubsection{Smith's method}

In this section, we analyze Smith's method, which allows to produce an accurate 
division of two complex numbers. We present the detailed steps of this modified 
algorithm in the particular cases that we have presented.

\index{Smith, Robert}
In Scilab, the algorithm which allows to perform the complex 
division is done by the the \emph{wwdiv} routine, which implements  
Smith's method \cite{Smith1962}.
This implementation is due to Bruno Pin{\c c}on.
Smith's algorithm is based on normalization, which allow to 
perform the complex division even if the input terms are large or small. 

The starting point of the method is the mathematical definition \ref{compdiv-eq-defcomplexdiv},
which is reproduced here for simplicity
\begin{eqnarray}
\label{compdiv-eq-defcomplexdiv2}
\frac{a + ib}{c + id} = e+if = \frac{ac + bd}{c^2 + d^2} + i \frac{bc - ad}{c^2 + d^2}.
\end{eqnarray}

Smith's method is based on the rewriting of this formula in 
two different, but mathematically equivalent, formulas. 
We have seen that the term $c^2 + d^2$ may generate overflows or underflows.
This is caused by intermediate expressions which magnitudes are larger than necessary.
The previous numerical experiments suggest that, provided that we 
had simplified the calculation, the intermediate expressions 
would not have been unnecessary large. 

Consider the term $e=\frac{ac + bd}{c^2 + d^2}$ in the equation \ref{compdiv-eq-defcomplexdiv2}
and assume that $c\neq 0$ and $d\neq0$.
Let us assume that $c$ is large in magnitude with respect to $d$, i.e. $|d|\ll|c|$. 
This implies $d/c \leq 1$. We see that the denominator $c^2 + d^2$ 
squares the number $c$, which also appears in the numerator. Therefore, 
we multiply both the numerator and the denominator by $1/c$. If we  
express $e$ as $\frac{a + b(d/c)}{c + d (d/c)}$, which is 
mathematically equivalent, we see that there is no more squaring of $c$.
Hence, overflows are less likely to occur in the denominator, since $|d (d/c)|= |d| |d/c| \leq |d|$.
That is, there is no growth in the magnitude of the terms involved in the 
computation of the product $d(d/c)$.
Similarly, overflows are less likely to occur in the numerator, since 
$|b(d/c)|= |b| |d/c| \leq |b|$. In the opposite case where $d$ is large with 
respect to $c$, i.e. $d\gg c$, we could divide the numerator and the denominator by $1/d$.
This leads to the formulas
\begin{eqnarray}
\frac{a + ib}{c + id} 
&=& \frac{a + b(d/c)}{c + d(d/c)} + i \frac{b - a(d/c)}{c + d(d/c)}, \\
&=& \frac{a(c/d) + b}{c(c/d) + d} + i \frac{b(c/d) - a}{c(c/d) + d}. 
\end{eqnarray}

The previous equations can be simplified as 
\begin{eqnarray}
\frac{a + ib}{c + id} 
&=& \frac{a + br}{c + dr} + i \frac{b - ar}{c + dr} , \qquad r = d/c, \textrm{ if } |c|\geq |d|,\\
&=& \frac{ar + b}{cr + d} + i \frac{br - a}{cr + d}, \qquad r = c/d, \textrm{ if } |d|\geq |c|.
\end{eqnarray}

The following \scifun{smith} function implements 
Smith's method in the Scilab language.
\lstset{language=scilabscript}
\begin{lstlisting}
function [e,f] = smith ( a , b , c , d )
  if ( abs(d) <= abs(c) ) then
    r = d/c;
    den = c + d * r;
    e = (a + b * r) / den;
    f = (b - a * r) / den;
  else
    r = c/d;
    den = c * r + d;
    e = (a * r + b) / den;
    f = (b * r - a) / den;
  end
endfunction
\end{lstlisting}

We now check that Smith's method performs very well for the difficult complex 
division that we met earlier in this chapter.

Let us analyze the second complex division \ref{eq-cd-10307}.
We have $a=1$, $b=1$, $c=1$ and $d=10^{307}$.
For this division, Smith's method is the following.
\begin{lstlisting}
if ( |1.e307| <= |1| ) > test false
else
  r = c/d = 1 / 1.e307 = 1.e-307
  den  = c * r + d = 1 * 1.e-307 + 1.e307 = 1.e307
  e = (a * r + b)/den = (1 * 1.e-307 + 1) / 1.e307 = 1 / 1.e307 
    = 1.e-307
  f = (b * r - a)/den = (1 * 1.e-307 - 1) / 1.e307 = -1 / 1.e307 
    = -1.e-308
\end{lstlisting}
We see that, while the naive division generated an overflow, Smith's 
method produces the correct result.

Let us analyze the second complex division \ref{eq-cd-thirdtest}.
We have $a=1$, $b=1$, $c=10^{-307}$ and $d=10^{-307}$.
\begin{lstlisting}
if ( |1.e-307| <= |1.e-307| ) > test true
  r = d/c = 1.e-307 / 1.e-307 = 1
  den  = c + d * r = 1.e-307 +  1e-307 * 1 = 2.e-307
  e = (a + b * r) / den = (1 + 1 * 1) / 2.e-307 = 2/2.e-307 
    = 1.e307
  f = (b - a * r) / den = (1 - 1 * 1) / 2.e-307 
    = 0
\end{lstlisting}
We see that, while the naive division generated an underflow, Smith's 
method produces the correct result.

Now that we have designed a more robust algorithm, we are interested in 
testing Smith's method on a more difficult case.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{One more step}

In this section, we show the limitations of Smith's method
and present an example where Smith's method does not perform as 
expected.

The following example is inspired by an example by Stewart's in \cite{214414}. 
While Stewart gives an example based on a machine with an exponent range 
$\pm 99$, we consider an example which is based on Scilab's doubles. 
Consider the complex division
\begin{eqnarray}
\frac{10^{307} +  i 10^{-307}}{10^{204} +   i 10^{-204}} 
\approx 1.000000000000000 \cdot 10^{103} -  i 1.000000000000000 \cdot 10^{-305},
\end{eqnarray}
which is accurate to the displayed digits. In fact, there are more that 100 zeros following the leading 
1, so that the previous approximation is very accurate.
The following Scilab session compares the naive implementation, Smith's method
and Scilab's division operator.
The session is performed with Scilab v5.2.0 under a 32 bits Windows
using a Intel Xeon processor.
\lstset{language=scilabscript}
\begin{lstlisting}
-->[e f] = naive ( 1.e307 , 1.e-307 , 1.e204 , 1.e-204 )
 f  =
    0.  
 e  =
   Nan  
-->[e f] = smith ( 1.e307 , 1.e-307 , 1.e204 , 1.e-204 )
 f  =
    0.  
 e  =
    1.000+103  
-->(1.e307 + %i * 1.e-307)/(1.e204 + %i * 1.e-204)
 ans  =
    1.000+103 - 1.000-305i  
\end{lstlisting}
In the previous case, the naive implementation does not produce any correct digit, as 
expected. Smith's method, produces a correct real part, but an inaccurate imaginary 
part. Once again, Scilab's division operator provides the correct 
answer.

We first check why the naive implementation is not accurate in this case.
We have $a=10^{307}$, $b=10^{-307}$, $c=10^{204}$ and $d=10^{-204}$.
Indeed, the naive implementation performs the following steps.
\begin{lstlisting}
  den = c * c + d * d = 1.e204 * 1.e204 + 1.e-204 * 1.e-204 
      = Inf
  e = (a * c + b * d) / den 
    = (1.e307 * 1.e204 + 1.e-307 * 1.e-204 ) / Inf = Inf / Inf 
    = Nan
  f = (b * c - a * d) / den 
    = (1.e-307 * 1.e204 - 1.e307 * 1.e-204) / Inf = -1.e103 / Inf 
    = 0
\end{lstlisting}
We see that the denominator \scivar{den} overflows, which 
makes \scivar{e} to be computed as \scivar{Nan} and \scivar{f} 
to be computed as \scivar{0}.

Second, we check that Smith's formula is not accurate in this 
case. Indeed, it performs the following steps.
\begin{lstlisting}
if ( abs(d) = 1.e-204 <= abs(c) = 1.e204 ) > test true
  r = d/c = 1.e-204 / 1.e204 = 0
  den  = c + d * r = 1.e204 +  1.e-204 * 0 = 1.e204
  e = (a + b * r) / den = (1.e307 + 1.e-307 * 0) / 1e204 
    = 1.e307 / 1.e204 = 1.e103
  f = (b - a * r) / den = (1.e-307 - 1.e307 * 0) / 1e204 
    = 1.e-307 / 1.e204 = 0
\end{lstlisting}
We see that the variable \scivar{r} underflows, so that it is 
represented by zero. 
This simplifies the denominator \scivar{den},
but this variable is still correctly computed, because it is dominated 
the term \scivar{c}. 
The real part \scivar{e} is still accurate, because,
once again, the computation is dominated by the term \scivar{a}.
The imaginary part \scivar{f} is wrong, because this term should be 
dominated by the term \scivar{a*r}. 
Since \scivar{r} underflows, it 
is represented by zero, which completely changes the result of the 
expression \scivar{b-a*r}, which is now equal to \scivar{b}.
Therefore, the result is equal to \scivar{1.e-307 / 1.e204}, which 
underflows to zero. 

Finally, we analyze why Scilab's division operator performs 
accurately in this case. Indeed, the formula used by Scilab 
is based on Smith's method and we proved that this method 
fails in this case, when we use double floating point numbers. 
Therefore, we experienced here an unexpected high accuracy.

We performed this particular complex division over several common 
computing systems such as various versions of Scilab, Octave, 
Matlab and FreeMat on various operating systems. The results are presented
in figure \ref{fig-compdiv-weird}. Notice that, on Matlab, 
Octave and FreeMat, the syntax is different and we 
used the expression \scivar{(1.e307 + i * 1.e-307)/(1.e204 + i * 1.e-204)}.

\begin{figure}
\begin{center}
\begin{tabular}{|l|l|l|}
\hline
Scilab v5.2.0 release & Windows 32 bits & 1.000+103 - 1.000-305i \\
Scilab v5.2.0 release & Windows 64 bits & 1.000+103 \\
Scilab v5.2.0 debug   & Windows 32 bits & 1.000+103 \\
Scilab v5.1.1 release & Windows 32 bits & 1.000+103 \\
Scilab v4.1.2 release & Windows 32 bits & 1.000+103 \\
Scilab v5.2.0 release & Linux 32 bits   & 1.000+103 - 1.000-305i \\
Scilab v5.1.1 release & Linux 32 bits   & 1.000+103 - 1.000-305i \\
Octave v3.0.3         & Windows 32 bits & 1.0000e+103 \\
Matlab 2008           & Windows 32 bits & 1.0000e+103 -1.0000e-305i \\
Matlab 2008           & Windows 64 bits & 1.0000e+103 \\
FreeMat v3.6          & Windows 32 bits & 1.0000e+103 -1.0000e-305i \\
\hline
\end{tabular}
\end{center}
\caption{Result of the complex division \scivar{(1.e307 + \%i * 1.e-307)/(1.e204 + \%i * 1.e-204)} on various 
softwares and operating systems.}
\label{fig-compdiv-weird}
\end{figure}

The reason of the discrepancies of the results is the following \cite{MullerEtAl2010,Monniaux2008}. 
The processor being used may offer an internal precision that is wider than the 
precision of the variables of a program. 
Indeed, processors of the IA32 architecture (Intel 386, 486, Pentium etc. and 
compatibles) feature a floating-point unit often known as "x87".
This unit has 80-bit registers in "double extended" format with a 64-bit mantissa and
a 15-bit exponent. The most usual way of generating code for the IA32 is to hold temporaries -
and, in optimized code, program variables - in the x87 registers.
Hence, the final result of the computations depend on how the compiler allocates registers.
Since the double extended format of the x87 unit uses 15 bits for the exponent, 
it can store floating point numbers associated with binary exponents from 
$2^{-16382}\approx 10^{-4932}$ up to $2^{16383}\approx 10^{4931}$,
which is much larger than the exponents from the 64-bits double precision 
floating point numbers (ranging from $2^{-1022}\approx 10^{-308}$ up to $2^{1023}\approx 10^{307})$.
Therefore, the computations performed with the x87 unit are less likely to 
generate underflows and overflows. On the other hand, SSE2 extensions introduced 
one 128-bit packed floating-point data type. This 128-bit data type consists of
two IEEE 64-bit double-precision floating-point values packed into a double
quadword.

Depending on the compilers options used to generate the binary,
the result may use either the x87 unit (with 80-bits registers) or the 
SSE unit. Under Windows 32 bits, Scilab v5.2.0 is compiled with the "/arch:IA32" 
option \cite{CordenKreitzerIntel2009}, which allows Scilab to run on 
older Pentium computers that does not support SSE2. In this situation,
Scilab may use the x87 unit. Under Windows 64 bits, Scilab uses the SSE2 unit so that the result 
is based on double precision floating point numbers only.
Under Linux, Scilab is compiled with gcc \cite{GCCManual2008}, 
where the behavior is driven by the -mfpmath option. The default value of this option for i386 machines 
is to use the 387 floating point co-processor while, for x86\_64 machines, the default 
is to use the SSE instruction set.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{References}

\index{Smith, Robert}
The 1962 paper by R. Smith \cite{Smith1962} describes the algorithm which is used in 
Scilab. 

\index{Goldberg, David}
Goldberg introduces in \cite{WhatEveryComputerScientist} many 
of the subjects presented in this document, including the problem of the 
complex division. 

An analysis of Hough, cited by Coonen \cite{1667289} and Stewart \cite{214414} 
shows that when the algorithm works, it returns a computed value $\overline{z}$
satisfying
\begin{eqnarray}
|\overline{z} - z| \leq \epsilon |z|,
\end{eqnarray}
where $z$ is the exact complex division result and $\epsilon$ is of the same order of magnitude 
as the rounding unit for the arithmetic in question. 

The limits of Smith's method have been analyzed by Stewart's in \cite{214414}.
The paper separates the relative error of the complex numbers and the relative
error made on real and imaginary parts. 
Stewart's algorithm is based on a theorem which states that if $x_1 \ldots x_n$
are $n$ floating point representable numbers, and if their product is also 
a representable floating point number, then the product $\min_{i=1,n}(x_i) . \max_{i=1,n}(x_i)$
is also representable. The algorithm uses that theorem to perform a 
correct computation.

\index{Kahan, William}
\index{Stewart, G. W.}
Stewart's algorithm is superseded by the one by Li et al. \cite{567808}, but 
also by Kahan's \cite{KAHAN1987}, which, from  \cite{1039814}, is the one implemented
in the C99 standard.

In \cite{567808}, Li et al. present an improved complex division algorithm with scaling. 
The section 6.1, "Environmental Enquiries", presents Smith's algorithm. 
The authors state that this algorithm can suffer from intermediate underflow. 
As complex division occurs rarely in the BLAS, the authors have chosen to have 
a more careful implementation. 
This implementation scales the numerator and denominator if they are two small 
or too large. 
An error bound is presented for this algorithm, which is presented 
in the appendix B. 
Notice that this appendix is presented in the technical report (October 20, 
2000), but not in the paper published by ACM (2002).

In the ISO/IEC 9899:TC3 C Committee Draft \cite{ProgrammingC}, the section G.5.1 
"Multiplicative operators", the authors present a \verb|_Cdivd| function which implements
the complex division. 
Their implementation only scales the denominator $c^2+d^2$. 
This scaling is based on a power of 2, which avoid extra rounding. 
Only in the case of an IEEE exceptions, the algorithm recompute the division, 
taking into account for Nans and Infinities. 
According to the authors, this solves the main overflow and underflow problem.
The code does not defend against overflow and underflow in the calculation of the numerator.
According to Kahan \cite{KahanMarketing2000} (in the Appendix "Over/Underflow Undermines 
Complex Number Division in Java"), this code is due to Jim Thomas and Fred Tydeman. 

\index{Knuth, Donald E.}
Knuth presents in \cite{artcomputerKnuthVol2}
the Smith's method in section 4.2.1, as exercize 16. Knuth gives also 
references \cite{Wynn:1962:AAP} and \cite{DBLP:journals/cacm/Friedland67}.
The 1967 paper by Friedland \cite{DBLP:journals/cacm/Friedland67} describes 
two algorithms to compute the absolute value of a complex number 
$|x+iy| = \sqrt{x^2+y^2}$ and the square root of a 
complex number $\sqrt{x+iy}$.

\index{Muller, Jean-Michel}
Issues related to the use of extended double precision floating point 
numbers are analyzed by Muller et al. in \cite{MullerEtAl2010}. 
In the section 3 of part I, "Floating point formats an Environment", 
the authors analyze the "double rounding" problem which occurs when an 
internal precision is wider than the precision of the variables of a 
program. The typical example is the double-extended format available 
on Intel platforms. Muller et al. show different examples, where the 
result depends on the compiler options and the platform, including an example extracted 
from a paper by Monniaux \cite{Monniaux2008}.

\index{Corden, Martyn}
\index{Kreitzer, David}
Corden and Kreitzer analyse in \cite{CordenKreitzerIntel2009} the 
effect of the Intel compiler floating point options on the numerical results.
The paper focuses on the reproductibility issues which are associated 
with floating point computations. The options which allow to be compliant 
with the IEEE standards for C++ and Fortran are presented.
The effects of optimization options is considered with respect to 
speed and the safety of the transformations that may be done on the 
source code.

The "Intel 64 and IA-32 Architectures Software Developer's Manual. Volume 1: Basic Architecture" 
\cite{Intel64IA32Architecture} is part of a set of documents that describes the architecture
and programming environment of Intel 64 and IA-32 architecture processors. The chapter 8, "Programming 
with the x87 environment" presents the registers and the 
instruction set for this unit. The section 8.1.2, "x87 FPU Data Registers" focuses 
on the floating point registers, which are based on 80-bits and implements 
the double extended-precision floating-point format. 
The chapter 10, "Programming with Streaming SIMD Extensions (SSE)" introduces the 
extensions which were introduced into the IA-32 architecture in
the Pentium III processor family. 
The chapter 11 introduces the SSE2 extensions.

\index{Monniaux, David}
In \cite{Monniaux2008}, David Monniaux presents issues related to the 
analysis of floating point programs. He emphasizes the difficulty
of defining the semantics of common implementation of floating point numbers,
depending on choices made by the compiler. He gives concrete examples of problems that 
can appear and solutions.

\index{Higham, Nicolas}
In the exercise 25.2 of the chapter 25 "Software issues in
floating  point arithmetic" of \cite{Higham:2002:ASN}, Nicolas Higham makes 
a link between the complex division and the Gaussian elimination. 
He suggest that Smith's algorithm can be derived 
from appliying the Gaussian elimination algorithm with partial pivoting obtained 
from $(c+id)(e+if)=a+ib$. 

In the Appendix B "Smith?s Complex Division Algorithm with Scaling", of \cite{Li2000}, 
Li et al. present a modified Smith's algorithm. 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\begin{footnotesize}
\subsection{Exercises}

\begin{exercise}[Complex division formula]
\label{exe-divisionformula}
Prove equality \ref{compdiv-eq-defcomplexdiv}.
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Complex division]
\label{exe-compdive1234}
Prove that $\frac{1 + i 2}{3 + i4} = \frac{11}{25}+i\frac{2}{25}$.
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Complex division]
\label{exe-compdive10307}
Prove a simplified version of the equation \ref{eq-cd-10307}, that is, prove that 
\begin{eqnarray}
\frac{1 + i}{1 + i 10^{307} } 
&\approx& 10^{-307} - i 10^{-307}.
\end{eqnarray}
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Taylor expansion of inverse function near zero]
\label{exe-compdivexpansionofinversezero}
Prove that if $x\in\RR$ is close to zero, then 
\begin{eqnarray}
\frac{1}{1 + x} = 1 - x + x^2 - x^3 + O(x^4).
\end{eqnarray}
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Taylor expansion of inverse function near $+\infty$]
\label{exe-compdivexpansionofinverseinf}
Prove that if $x\in\RR$ is close to $+\infty$, then 
\begin{eqnarray}
\label{eq-compdiv-Taylorinvinv}
\frac{1}{1 + x} = \frac{1}{x} - \left(\frac{1}{x}\right)^2 + \left(\frac{1}{x}\right)^3 
+ O\left(\left(\frac{1}{x}\right)^4\right).
\end{eqnarray}
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Complex division approximation]
\label{exe-compdive10307exact}
Prove that the approximation \ref{eq-cd-10307} is accurate to more that 
300 digits, that is, prove that 
\begin{eqnarray}
\frac{1 + 10^{307}}{1 + 10^{614}}  = 10^{-307} + O(10^{-614}).
\end{eqnarray}
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Complex division approximation]
\label{exe-cp-mn}
Assume that $m,n$ are integers which satisfy
\begin{eqnarray}
m \gg 0 \label{eq-cp-mn-m>>0}\\
n \gg 0 \label{eq-cp-mn-n>>0}\\
n \gg m \label{eq-cp-mn-n>>m}
\end{eqnarray}
Prove that 
\begin{eqnarray}
\label{eq-cp-mn-approx}
\frac{10^n + i 10^{-n}}{10^m + i 10^{-m}} \approx 10^{n-m} - i 10^{n-3m}.
\end{eqnarray}
\end{exercise}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Complex division approximation]
\label{exe-cp-mnIEEE}
Assume that the integers $m$ and $n$ satisfy 
\begin{eqnarray}
4 < m \leq 308, \label{eq-cp-mn-mdouble} \\
12 < n \leq 308, \label{eq-cp-mn-ndouble}\\
m + 8 < n, \label{eq-cp-mn-mn8}\\
0\leq n-m \leq 308, \label{eq-cp-mn-m-ndouble} \\
-307\leq n-3m \leq 0. \label{eq-cp-mn-m-3mdouble}
\end{eqnarray}
Prove that the approximation \ref{eq-cp-mn-approx} is 
an equality with double precision floating point numbers and prove that 
all the terms in the expression \ref{eq-cp-mn-approx} are representable 
as floating point numbers.
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Examples of failing Smith's formula]
\label{exe-cp-mnsmithfails}
Assume that the integers $m$ and $n$ satisfy the inequalities \ref{eq-cp-mn-mdouble} to \ref{eq-cp-mn-m-3mdouble}.
Assume that the integers $m$ and $n$ satisfy the inequalities 
\begin{eqnarray}
162<m, \label{eq-cp-mn-smith1} \\
324 < m+n \label{eq-cp-mn-smith2}.
\end{eqnarray}
Prove that Smith's method fails to compute a correct result for the complex 
division \ref{eq-cp-mn-approx} with double floating point numbers, that is, 
prove that the imaginary part computed by Smith's method is zero. 
\end{exercise}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{exercise}[Examples of failing Smith's formula]
\label{exe-cp-mnsmithfailsexamples}
Compute the number of integers $m$ and $n$ satisfying the assumptions of exercise \ref{exe-cp-mnIEEE}.
Give examples of such integers $m$ and $n$.

Compute the number of integers $m$ and $n$ satisfying the assumptions of exercise \ref{exe-cp-mnsmithfails}.
Give examples of such integers $m$ and $n$.
\end{exercise}



\end{footnotesize}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{footnotesize}

\subsection{Answers to exercises}

\begin{answer}{\ref{exe-divisionformula}}{Complex division formula}
Let us prove equality \ref{compdiv-eq-defcomplexdiv}.
We consider the fraction $\frac{a + ib}{c + id}$
and we multiply both the numerator and the denominator 
by the number $\overline{c + id} = c - id$. This leads to 
\begin{eqnarray}
\frac{a + ib}{c + id} 
&=&\frac{a + ib}{c + id} \frac{c - id}{c - id} \\
&=&\frac{(ac - i^2bd)+i(bc-ad)}{c^2+d^2}\\
&=&\frac{(ac + bd)+i(bc-ad)}{c^2+d^2}.
\end{eqnarray}
We separate the real and imaginary parts in the previous equations and finally 
get the equality \ref{compdiv-eq-defcomplexdiv}.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-compdive1234}}{Complex division formula}
By the equation \ref{compdiv-eq-defcomplexdiv}, we have 
\begin{eqnarray}
\frac{1 + i 2}{3 + i 4} 
&=& \frac{1\cdot 3 + 2\cdot 4}{3^2 + 4^2} + i \frac{2\cdot 3 - 1\cdot 4}{3^2 + 4^2} \\
&=& \frac{3 + 8}{9 + 16} + i \frac{6 - 4}{9 + 16} \\
&=& \frac{11}{25} + i \frac{2}{25}.
\end{eqnarray}
\end{answer}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-compdive10307}}{Complex division}
By the equation \ref{compdiv-eq-defcomplexdiv}, we have 
\begin{eqnarray}
\frac{1 + i}{1 + 10^{307} i } 
&=& \frac{1\cdot 1 + 1\cdot 10^{307}}{1^2 + (10^{307})^2} + i \frac{1\cdot 1 - 1\cdot 10^{307}}{1^2 + (10^{307})^2} \\
&=& \frac{1 + 10^{307}}{1 + 10^{614}} + i \frac{1 - 10^{307}}{1 + 10^{614}} \label{eq-cd10307-exact}\\
&\approx& \frac{10^{307}}{10^{614}} - i \frac{10^{307}}{10^{614}} \\
&\approx& 10^{-307} - i 10^{-307}.
\end{eqnarray}
\end{answer}



%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-compdivexpansionofinversezero}}{Taylor expansion of inverse function near zero}
Assume that $f$ is a continuously differentiable function. 
By Taylor's theorem, we have
\begin{eqnarray}
\label{eq-compdiv-Taylor-1D}
f(x+h) = f(x) + h f^\prime(x) + \frac{1}{2} h^2 f^{\prime\prime}(x)
+ \frac{1}{6} h^3 f^{\prime\prime\prime}(x) + O(h^4).
\end{eqnarray}
We use the Taylor's expansion \ref{eq-compdiv-Taylor-1D} with $f(x)=\frac{1}{1+x}$
in the neighborhood of $x=0$. 
The derivatives of the function $f$ are 
\begin{eqnarray}
f^\prime(x) = -(1+x)^{-2}, \qquad 
f^{\prime\prime}(x) = 2(1+x)^{-3},\qquad  
f^{\prime\prime\prime}(x) = -6(1+x)^{-4},
\end{eqnarray}
so that 
\begin{eqnarray}
f(0) = 1, \qquad 
f^\prime(0) = -1, \qquad 
f^{\prime\prime}(0) = 2, \qquad
f^{\prime\prime\prime}(0) &=& -6.
\end{eqnarray}
The Taylor expansion \ref{eq-compdiv-Taylor-1D} therefore implies 
\begin{eqnarray}
\frac{1}{1+h} &=& 1 +  h \cdot (-1) + \frac{1}{2} h^2 \cdot 2 
+ \frac{1}{6} h^3 \cdot (-6) + O(h^4),\\
&=& 1 - h + h^2 - h^3 + O(h^4),
\end{eqnarray}
which concludes the proof.
\end{answer}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-compdivexpansionofinverseinf}}{Taylor expansion of inverse function near $+\infty$}
When $x\rightarrow +\infty$, we have $1/x\rightarrow 0$.
Therefore, we can use the result of the exercise \ref{exe-compdivexpansionofinversezero},
which implies 
\begin{eqnarray}
\label{eq-compdiv-Taylorinvinvx}
\frac{1}{1+1/x} &=& 1 - (1/x) + (1/x)^2 - (1/x)^3 + O((1/x)^4).
\end{eqnarray}
We can simplify the previous expression. Indeed, 
\begin{eqnarray}
\frac{1}{1+1/x} 
&=& \frac{1}{\frac{1+x}{x}} \\
&=& \frac{x}{1+x} \\
&=& \frac{x+1-1}{1+x} \\
&=& 1 - \frac{1}{1+x}.
\end{eqnarray}
By the equation \ref{eq-compdiv-Taylorinvinvx}, this leads to 
\begin{eqnarray}
1 - \frac{1}{1+x}
&=& 1 - (1/x) + (1/x)^2 - (1/x)^3 + O((1/x)^4).
\end{eqnarray}
In the previous equation, the constant term 1 can be simplified
from both sides, which immediately leads to the equation \ref{eq-compdiv-Taylorinvinv}
and concludes the proof.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-compdive10307exact}}{Complex division approximation}
Let us prove that the approximation \ref{eq-cd-10307} is accurate to more that 
300 digits, that is, let us prove that 
\begin{eqnarray}
\frac{1 + 10^{307}}{1 + 10^{614}}  = 10^{-307} + O(10^{-614}).
\end{eqnarray}
The starting point is the equality \ref{eq-cd10307-exact}, which we rewrite 
here for consistency:
\begin{eqnarray}
\frac{1 + i}{1 + i 10^{307} } 
&=& \frac{1 + 10^{307}}{1 + 10^{614}} + i \frac{1 - 10^{307}}{1 + 10^{614}}.
\end{eqnarray}
We use the Taylor expansion \ref{eq-compdiv-Taylorinvinv} in order to compute the 
expression $\frac{1}{1 + 10^{614}}$, and then compute the fraction $\frac{1 + 10^{307}}{1 + 10^{614}}$.
By the Taylor expansion \ref{eq-compdiv-Taylorinvinv}, we have 
\begin{eqnarray}
\frac{1}{1 + 10^{614}}
&=& \frac{1}{10^{614}} + O\left(\left(\frac{1}{10^{614}}\right)^2\right)\\
&=& 10^{-614} + O(10^{-1228}).
\end{eqnarray}
Therefore, 
\begin{eqnarray}
\frac{1 + 10^{307}}{1 + 10^{614}}
&=& (1 + 10^{307})(10^{-614} + O(10^{-1228})) \\
&=& 10^{-614} + O(10^{-1228}) + 10^{-307} + O(10^{-921})\\
&=& 10^{-307} + O(10^{-614}).
\end{eqnarray}
The last equality proves that the approximation $\frac{1 + 10^{307}}{1 + 10^{614}} \approx 1.0\ldots 0 \cdot 10^{-307}$
is accurate up to 306 zeros.
Similarily, we have 
\begin{eqnarray}
\frac{1 - 10^{307}}{1 + 10^{614}}
&=& (1 - 10^{307})(10^{-614} + O(10^{-1228})) \\
&=& 10^{-614} + O(10^{-1228}) - 10^{-307} + O(10^{-921})\\
&=& -10^{-307} + O(10^{-614}).
\end{eqnarray}
Therefore, the approximation $\frac{1 - 10^{307}}{1 + 10^{614}} \approx -1.0\ldots 0 \cdot 10^{-307}$
is accurate up to 306 zeros.
This proves that the approximation \ref{eq-cd-10307} is accurate 
to more that 300 digits and concludes the proof.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-cp-mn}}{Complex division approximation}
By the equation \ref{compdiv-eq-defcomplexdiv}, we have
\begin{eqnarray}
\frac{10^n + i 10^{-n}}{10^m + i 10^{-m}} 
&=& \frac{10^n 10^m + 10^{-n}10^{-m}}{(10^m)^2 + (10^{-m})^2} +  
 i \frac{10^{-n} 10^m - 10^n 10^{-m}}{(10^m)^2 + (10^{-m})^2}  \\
&=& \frac{10^{n+m} + 10^{-(m+n)}}{10^{2m} + 10^{-2m}} +  
i \frac{10^{m-n} - 10^{n-m}}{10^{2m} + 10^{-2m}}.
\label{eq-cp-mn-exact}
\end{eqnarray}
We will now use the assumptions \ref{eq-cp-mn-m>>0} to \ref{eq-cp-mn-n>>m} and simplify the 
previous equation. 
\begin{itemize}
\item The assumptions \ref{eq-cp-mn-m>>0} and \ref{eq-cp-mn-n>>0} implies $m+n \gg 0$. 
Therefore, 
\begin{eqnarray}
10^{n+m} + 10^{-(m+n)} \approx 10^{n+m}.
\end{eqnarray}
\item By the assumption \ref{eq-cp-mn-m>>0}, we have 
\begin{eqnarray}
10^{2m} + 10^{-2m} \approx 10^{2m}.
\end{eqnarray}
\item The assumption \ref{eq-cp-mn-n>>m} implies $n-m \gg 0$. Therefore, 
\begin{eqnarray}
10^{m-n} - 10^{n-m} \approx - 10^{n-m}.
\end{eqnarray}
\end{itemize}
Therefore, the equation \ref{eq-cp-mn-exact} simplifies into
\begin{eqnarray}
\frac{10^n + i 10^{-n}}{10^m + i 10^{-m}} 
&\approx& \frac{10^{n+m}}{10^{2m}} +  
i \frac{- 10^{n-m}}{10^{2m}} \\
&\approx& 10^{n-m} - i 10^{n-3m}.
\end{eqnarray}
We could prove that this approximation is correct up to approximately several 100 digits.
This would require to use a Taylor expansion, as we did previously.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-cp-mnIEEE}}{Complex division approximation}
Assume that we consider IEEE double precision floating point numbers.
Assume that $x$ and $y$ are integers and satisfy $-307 \leq x,y \leq 308$.
Double precision numbers are associated with at most 16 significant decimal digits.
Therefore, if $x > y + 16$, we have 
\begin{eqnarray}
fl(10^x + 10^y) = fl(10^x).
\label{eq-cp-mn-roundoff}
\end{eqnarray}
We will use this property throughought this exercise.

We are going to prove that, under the stated assumptions, we have 
\begin{eqnarray}
\label{eq-cp-mn-exactfp}
fl \left( \frac{10^n + i 10^{-n}}{10^m + i 10^{-m}} \right) = fl ( 10^{n-m} - i 10^{n-3m} ).
\end{eqnarray}

We consider the equality \ref{eq-cp-mn-exact} and consider the 
particular range of integers which are so that the approximations that 
we derived from there are satisfied with doubles.
\begin{itemize}
\item By the equality \ref{eq-cp-mn-roundoff}, the equality
\begin{eqnarray}
fl(10^{n+m} + 10^{-(m+n)}) =fl(10^{n+m})
\end{eqnarray}
is true if $n+m> -(m+n) + 16$. This is equivalent to $2(m+n)>16$ which 
can be written  
\begin{eqnarray}
m+n > 8.
\label{eq-cp-mn-roundoff1}
\end{eqnarray}
\item By the equality \ref{eq-cp-mn-roundoff}, the equality
\begin{eqnarray}
fl( 10^{2m} + 10^{-2m} ) = fl(10^{2m})
\end{eqnarray}
is true if $2m > -2m + 16$. This is equivalent to $4m>16$ which can
be written 
\begin{eqnarray}
m>4.
\label{eq-cp-mn-roundoff2}
\end{eqnarray}
\item By the equality \ref{eq-cp-mn-roundoff}, the equality
\begin{eqnarray}
fl( 10^{m-n} - 10^{n-m} ) = fl( - 10^{n-m})
\end{eqnarray}
is true if $n-m > m-n + 16$. This is equivalent to 
$2(n-m) > 16$ and can be written as 
\begin{eqnarray}
n > m + 8.
\label{eq-cp-mn-roundoff3}
\end{eqnarray}
\end{itemize}
Notice that, if $m>4$ and $n>m+8$, then $n>4+8=12$ which is implied by the inequality \ref{eq-cp-mn-ndouble}.
If the inequalities \ref{eq-cp-mn-roundoff1}, \ref{eq-cp-mn-roundoff2} and 
\ref{eq-cp-mn-roundoff3} are satisfied, then the equality \ref{eq-cp-mn-exactfp} is satisfied.
Assume that the inequalities \ref{eq-cp-mn-mdouble}, \ref{eq-cp-mn-ndouble}
and \ref{eq-cp-mn-mn8} are satisfied. Let us prove that this imply that the inequalities 
\ref{eq-cp-mn-roundoff1}, \ref{eq-cp-mn-roundoff2} and \ref{eq-cp-mn-roundoff3} are satisfied. 
\begin{itemize}
\item By the inequalities \ref{eq-cp-mn-mdouble} and \ref{eq-cp-mn-ndouble},
we have $m>4$ and $n>12$, which imply $m+n>16$ so that the inequality \ref{eq-cp-mn-roundoff1} is satisfied. 
\item By the inequality \ref{eq-cp-mn-mdouble}, we have $m>4$, so that \ref{eq-cp-mn-roundoff2} is satisfied.
\item By assumption, we have \ref{eq-cp-mn-mn8}, which is identical to \ref{eq-cp-mn-roundoff3}.
\end{itemize}
Therefore, we have prove that the inequalities \ref{eq-cp-mn-mdouble}, \ref{eq-cp-mn-ndouble}
and \ref{eq-cp-mn-mn8} leads the floating point equality \ref{eq-cp-mn-exactfp}.

It is easy to prove that when the inequalities \ref{eq-cp-mn-mdouble} to \ref{eq-cp-mn-m-3mdouble}
are satisfied, then all the terms in the complex division \ref{eq-cp-mn-exactfp} 
are representable as double precision floating point numbers.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-cp-mnsmithfails}}{Examples of failing Smith's formula}
Assume that the integers $m$ and $n$ satisfy the inequalities \ref{eq-cp-mn-mdouble} to \ref{eq-cp-mn-m-3mdouble}.
Let us consider the steps of Smith's method in the particular case of the complex 
division \ref{eq-cp-mn-exactfp}.
We have $a=10^n$, $b=10^{-n}$, $c=10^m$ and $d=10^{-m}$.
Since $|d|=10^{-m} \leq |c|=10^m$, the floating point statements 
of Smith's method are the following.
\begin{eqnarray}
fl(r) &=& fl(d/c) = fl(10^{-m} / 10^m) = fl(10^{-2m}) \\
fl(den) &=& fl(c + d r) = fl(10^m + 10^{-m} 10^{-2m}) = fl(10^m + 10^{-3m})\\
&=&fl(10^m)\\
fl(e) &=& fl((a + b r) / den) = fl((10^n + 10^{-n} 10^{-2m})/(10^m + 10^{-3m})) \\
&=& fl((10^n + 10^{-n-2m})/(10^m + 10^{-3m})) = fl(10^n/10^m)\\
&=& fl(10^{n-m})\\
fl(f) &=& fl((b - a r) / den) = fl((10^{-n} - 10^n 10^{-2m})/(10^m + 10^{-3m})) \\
&=& fl((10^{-n} - 10^{n -2m})/(10^m + 10^{-3m})) = fl(- 10^{n -2m} / 10^m)\\
&=& fl(- 10^{n -3m})
\end{eqnarray}
We now justify the approximations that we have used in the 
previous computation, which are mainly based on the equality \ref{eq-cp-mn-roundoff}.
\begin{itemize}
\item We have $fl(10^m + 10^{-3m})= fl(10^m)$. Indeed, by assumption \ref{eq-cp-mn-mdouble}, 
we have $m>4$, which implies $4m>16$. This leads to $m>-3m+16$ and the equation \ref{eq-cp-mn-roundoff}
proves the result.
\item We have $fl(10^n + 10^{-n-2m}) = fl(10^n)$. Indeed, by the assumptions \ref{eq-cp-mn-mdouble} 
and \ref{eq-cp-mn-ndouble}, we have $m>4$ and $n>12$, so that $m+n>16>8$. Therefore, we have 
$2m+2n>16$, which implies $n>-n-2m+16$ and the equation \ref{eq-cp-mn-roundoff}
proves the result.
\item We have $fl(10^{-n} - 10^{n -2m}) = fl(- 10^{n -2m})$. Indeed, by the 
assumption \ref{eq-cp-mn-mn8}, we have $n>m+8$. This implies $n-m>8$, which leads to 
$2n-2m>16$. We finally get $n-2m>-n+16$ and the equation \ref{eq-cp-mn-roundoff}
proves the result.
\end{itemize}

We now search conditions which produce a failure of Smith's method, that is, 
we prove the inequalities \ref{eq-cp-mn-smith1} and \ref{eq-cp-mn-smith2}
leads to a failure of the previous formulas. 

We notice that, if $m$ is sufficiently large, then $r=10^{-2m}$ cannot 
be represented as a double. This happens if $-2m<-324$, so that $r=10^{-2m} < 10^{-324}$,
which is the smallest positive nonzero double. The assumption $m>162$ is 
implied by the inequality \ref{eq-cp-mn-smith1}, which leads to $fl(r)=0$.
This implies that $fl(den) = fl(c + d r) = fl(c) = fl(10^m)$. 
This implies that $fl(f) = fl((b - a r) / den) = fl(b/den) = fl(10^{-n}/10^m) = fl(10^{-n-m})$.
The imaginary part of the complex division $f$ is zero if $-n-m<324$. 
This is the assumption of the inequality \ref{eq-cp-mn-smith2}.
We have proved that the inequalities \ref{eq-cp-mn-smith1} and \ref{eq-cp-mn-smith2}
leads to a zero floating point representation of $f$, the imaginary part of the complex 
division.
\end{answer}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\begin{answer}{\ref{exe-cp-mnsmithfailsexamples}}{Examples of failing Smith's formula}
Let us compute the number of integers $m$ and $n$ satisfying the assumptions of exercise \ref{exe-cp-mnIEEE}.
The following Scilab script allows to compute these couples $(n,m)$,
by performing two nested loops in the allowed range for $n$ and $m$.
\lstset{language=scilabscript}
\begin{lstlisting}
N = 0;
for m = 5:308
  for n = 13:308
    if ( (m + 8 < n) & (n-m>=0) & (n-m <308) & ...
      (n-3*m >= -307) & (n-3*m<=0) ) then
      N = N + 1;
     end
   end
end
\end{lstlisting}
We find that there are 22484 such couples.
In order to extract some examples from all these couples, we add 
the condition \scivar{modulo(n,20)==0 \& modulo(m,20)==0}
in the \scivar{if} statement.
The following is a list of some examples.
\lstset{language=scilabscript}
\begin{lstlisting}
n=40, m=20
n=220, m=80
n=140, m=120
n=260, m=140
n=280, m=160
\end{lstlisting}
It is easy to check our result with Wolfram Alpha\cite{WWWWolframAlpha}, for example with 
the input "(10$\hat{\;}$140 + 10$\hat{\;}$-140 * i)/(10$\hat{\;}$20 + 10$\hat{\;}$-20 * i)".

Let us compute the number of integers $m$ and $n$ satisfying the 
assumptions of exercise \ref{exe-cp-mnsmithfails}.
The following Scilab script allows to compute these couples $(n,m)$,
by performing two nested loops in the allowed range for $n$ and $m$.
\lstset{language=scilabscript}
\begin{lstlisting}
N = 0;
for m = 163:308
  for n = 13:308
    if ( (m + 8 < n) & (n-m>=0) & (n-m <308) ...
      & (n-3*m >= -307) & (n-3*m<=0) & (n+m>324) ) then
      N = N + 1;
    end
  end
end
\end{lstlisting}
We find 2752 such couples.
In order to extract some examples from all these couples, we add 
the condition \scivar{modulo(n,20)==0 \& modulo(m,20)==0}
in the \scivar{if} statement.
The following is a list of some examples.
\lstset{language=scilabscript}
\begin{lstlisting}
n=240, m=180
n=260, m=180
n=280, m=180
n=300, m=180
n=300, m=200
\end{lstlisting}
We notice that 2752/22484= 0.122 (which is accurate to the displayed 
digits) that, when the complex division \ref{eq-cp-mn-exactfp} is considered, it is 
not rare that Smith's method fails.

\end{answer}
\end{footnotesize}



